diff --git a/game/core/src/main/java/net/minecraft/core/item/ItemRope.java b/game/core/src/main/java/net/minecraft/core/item/ItemRope.java
index fc0c9432c..c5d2c7c3e 100644
--- a/game/core/src/main/java/net/minecraft/core/item/ItemRope.java
+++ b/game/core/src/main/java/net/minecraft/core/item/ItemRope.java
@@ -2,63 +2,48 @@ package net.minecraft.core.item;
 
 import net.minecraft.core.block.Block;
 import net.minecraft.core.block.BlockLogicRope;
+import net.minecraft.core.block.entity.TileEntityActivator;
 import net.minecraft.core.entity.player.Player;
-import net.minecraft.core.enums.EnumBlockSoundEffectType;
+import net.minecraft.core.util.helper.Direction;
 import net.minecraft.core.util.helper.Side;
 import net.minecraft.core.world.World;
 import net.minecraft.core.world.pos.TilePos;
 import net.minecraft.core.world.pos.TilePosc;
+
+import java.util.Random;
+
 import org.jetbrains.annotations.NotNull;
 import org.jetbrains.annotations.Nullable;
 
 public class ItemRope extends ItemPlaceable {
-    public ItemRope(@NotNull String name, @NotNull String namespaceId, int id, @NotNull Block<?> blockToPlace) {
+    public ItemRope(@NotNull String name, @NotNull String namespaceId, int id, @NotNull Block<BlockLogicRope> blockToPlace) {
         super(name, namespaceId, id, blockToPlace);
     }
 
     @Override
     public boolean onUseOnBlock(@NotNull ItemStack selfStack, @NotNull World world, @Nullable Player player, @NotNull TilePosc blockPos, @NotNull Side side, double xHit, double yHit) {
-        if (selfStack.stackSize <= 0) {
-            return false;
-        }
-        TilePos bp = new TilePos(blockPos);
-        boolean placeOnSide = true;
-        if (world.getBlockType(bp) == this.blockToPlace && player != null && !player.isSneaking()) {
-            placeOnSide = false;
-            TilePos tempPos = new TilePos(bp);
-            while (tempPos.y > 0) {
-                tempPos.y--;
-                if (world.canBlockIdBePlacedAt(this.blockToPlace.id(), tempPos, false, side)) {
-                    bp.y = tempPos.y;
-                    break;
-                } else if (world.getBlockType(tempPos) != this.blockToPlace) {
-                    if (side == Side.TOP) {
-                        tempPos.y++;
-                        break;
-                    }
-                    return true;
-                }
-            }
-            bp.set(tempPos);
-        }
-        if (!world.canPlaceInsideBlock(bp)) {
-            bp = bp.add(side.direction(), new TilePos());
-        }
-        if (bp.y < 0 || bp.y >= world.getHeightBlocks()) {
-            return false;
-        }
-        if (world.canBlockIdBePlacedAt(this.blockToPlace.id(), bp, false, side) && selfStack.consumeItem(player)) {
-            if (world.setBlockTypeData(bp, this.blockToPlace, placeOnSide ? BlockLogicRope.MASK_ROPE_CONNECT : 0)) {
-                if (player == null) {
-                    this.blockToPlace.onPlacedOnSide(world, bp, side, xHit, yHit);
-                } else {
-                    this.blockToPlace.onPlacedByMob(world, bp, side, player, xHit, yHit);
-                }
-                world.notifyBlockChange(bp, this.blockToPlace);
-                world.playBlockSoundEffect(player, bp.x + 0.5F, bp.y + 0.5F, bp.z + 0.5F, this.blockToPlace, EnumBlockSoundEffectType.PLACE);
-                return true;
-            }
+        if (selfStack.stackSize <= 0) return false;
+
+        final var placePos = new TilePos(blockPos);
+        final boolean placeOnSide =
+            side != Side.TOP &&
+            (player == null || !player.isSneaking()) &&
+            world.getBlockType(placePos) == this.block;
+
+        if (placeOnSide) while (placePos.y-- > 0) {
+            if (world.getBlockType(placePos) == this.block) continue;
+            if (world.canBlockIdBePlacedAt(this.block.id(), placePos, false, side)) break;
+            else return false;
         }
-        return false;
+        if (super.shouldShiftOutOf(selfStack, world, player, placePos, side, xHit, yHit)) placePos.add(side);
+
+        final int meta = (placeOnSide) ? BlockLogicRope.MASK_ROPE_CONNECT : 0;
+        return super.placeDirectly(selfStack, world, player, placePos, meta, side, xHit, yHit);
+    }
+
+    @Override
+    public void onUseByActivator(@NotNull ItemStack selfStack, @NotNull World world, @NotNull TileEntityActivator activator, @NotNull Random random, @NotNull TilePosc blockPos, @NotNull Direction direction, double offX, double offY, double offZ) {
+        blockPos = blockPos.add(direction, new TilePos());
+        this.onUseOnBlock(selfStack, world, null, blockPos, direction.opposite().side(), Double.NaN, Double.NaN);
     }
 }
diff --git a/game/core/src/main/java/net/minecraft/core/item/ItemStack.java b/game/core/src/main/java/net/minecraft/core/item/ItemStack.java
index d8e53be79..998e08a73 100644
--- a/game/core/src/main/java/net/minecraft/core/item/ItemStack.java
+++ b/game/core/src/main/java/net/minecraft/core/item/ItemStack.java
@@ -526,4 +526,12 @@ public final class ItemStack {
         this.tag.putInt(key, value);
         return this;
     }
+
+    public boolean interactsWithFluid() {
+        return this.getItem().interactsWithFluid(this);
+    }
+
+    public boolean interactsWithEntity(@NotNull Entity entity) {
+        return this.getItem().interactsWithEntity(this, entity);
+    }
 }
diff --git a/game/core/src/main/java/net/minecraft/core/item/ItemStatue.java b/game/core/src/main/java/net/minecraft/core/item/ItemStatue.java
index 6c6cab39d..c759d0ed2 100644
--- a/game/core/src/main/java/net/minecraft/core/item/ItemStatue.java
+++ b/game/core/src/main/java/net/minecraft/core/item/ItemStatue.java
@@ -1,11 +1,7 @@
 package net.minecraft.core.item;
 
 import net.minecraft.core.block.Block;
-import net.minecraft.core.block.entity.TileEntity;
-import net.minecraft.core.block.entity.TileEntityActivator;
 import net.minecraft.core.entity.player.Player;
-import net.minecraft.core.enums.EnumBlockSoundEffectType;
-import net.minecraft.core.util.helper.Direction;
 import net.minecraft.core.util.helper.MathHelper;
 import net.minecraft.core.util.helper.Side;
 import net.minecraft.core.world.World;
@@ -13,82 +9,38 @@ import net.minecraft.core.world.pos.TilePos;
 import net.minecraft.core.world.pos.TilePosc;
 import org.jetbrains.annotations.NotNull;
 import org.jetbrains.annotations.Nullable;
+import org.joml.primitives.AABBd;
 
-import java.util.Random;
-
-public class ItemStatue extends Item {
-    protected final @NotNull Block<?> statueBlockBottom;
-    protected final @NotNull Block<?> statueBlockTop;
-
+public class ItemStatue extends ItemPlaceablePair {
     public ItemStatue(@NotNull String name, @NotNull String namespaceId, int id, @NotNull Block<?> statueBlockBottom, @NotNull Block<?> statueBlockTop) {
-        super(name, namespaceId, id);
-        this.maxStackSize = 64;
-        this.statueBlockBottom = statueBlockBottom;
-        this.statueBlockTop = statueBlockTop;
+        super(name, namespaceId, id, statueBlockBottom, statueBlockTop);
     }
 
     @Override
-    public boolean onUseOnBlock(@NotNull ItemStack selfStack, @NotNull World world, @Nullable Player player, @NotNull TilePosc blockPos, @NotNull Side side, double xHit, double yHit) {
-        if (!world.canPlaceInsideBlock(blockPos)) {
-            blockPos = blockPos.add(side.direction(), new TilePos());
-        }
-        if (!this.statueBlockBottom.canPlaceAt(world, blockPos)) {
-            return false;
-        }
-
-        final var bb = statueBlockBottom.getCollisionAABB(world, blockPos);
-        if (bb != null && !world.checkIfAABBIsClear(bb)) {
-            return false;
-        }
-
-        selfStack.consumeItem(player);
-        world.setBlockTypeData(blockPos, this.statueBlockBottom, MathHelper.floor((double) (((player.yRot + 180F) * 16F) / 360F) + 0.5D) & 0xf);
-        world.setBlockTypeData(blockPos.up(new TilePos()), this.statueBlockTop, MathHelper.floor((double) (((player.yRot + 180F) * 16F) / 360F) + 0.5D) & 0xf);
-        world.markBlockNeedsUpdate(blockPos);
-        world.markBlockNeedsUpdate(blockPos.up(new TilePos()));
-        
-        this.statueBlockBottom.onPlacedByMob(world, blockPos, side, player, xHit, yHit);
-        this.statueBlockTop.onPlacedByMob(world, blockPos.up(new TilePos()), side, player, xHit, yHit);
-
-        if (this.statueBlockBottom.isEntityTile && selfStack.getData().containsKey("tileEntityData")) {
-            TileEntity tileEntity = world.getTileEntity(blockPos);
-            if (tileEntity != null) {
-                tileEntity.readAdditionalData(selfStack.getData().getCompound("tileEntityData"));
-            }
-        }
-        world.notifyBlocksInCapsuleOfNeighborChange(Direction.UP, blockPos, this.statueBlockBottom);
-        
-        world.playBlockSoundEffect(player, blockPos.x() + 0.5F, blockPos.y() + 0.5F, blockPos.z() + 0.5F, this.statueBlockBottom, EnumBlockSoundEffectType.PLACE);
-
-        return true;
+    protected @NotNull PlacementResult getPlacement(
+        @NotNull ItemStack selfStack,
+        @NotNull World world, @Nullable Player player, @NotNull TilePosc blockPos,
+        @NotNull Side side, double xHit, double yHit,
+        @NotNull PlacementResult result
+    ) {
+        final double yRot;
+        if (player == null) yRot = side.direction.opposite().yaw();
+        else if (player.rotationLockHorizontal != null) yRot = player.rotationLockHorizontal.yaw();
+        else yRot = player.yRot;
+
+        result.dataA = result.dataB = MathHelper.floor(((yRot + 180D) * (16D / 360D)) + 0.5D) & 0xF;
+        result.offsetB.set(0,1,0);
+        return result;
     }
 
     @Override
-    public void onUseByActivator(@NotNull ItemStack selfStack, @NotNull World world, @NotNull TileEntityActivator activator, @NotNull Random random, @NotNull TilePosc blockPos, @NotNull Direction direction, double offX, double offY, double offZ) {
-        if (!world.canPlaceInsideBlock(blockPos)) {
-            blockPos = blockPos.add(direction, new TilePos());
-        }
-        if (!this.statueBlockBottom.canPlaceAt(world, blockPos)) {
-            return;
-        }
-
-        world.setBlockType(blockPos, this.statueBlockBottom);
-        world.setBlockType(blockPos.up(new TilePos()), this.statueBlockTop);
-        world.markBlockNeedsUpdate(blockPos);
-        world.markBlockNeedsUpdate(blockPos.up(new TilePos()));
-        world.notifyBlocksInCapsuleOfNeighborChange(Direction.UP, blockPos, this.statueBlockBottom);
-
-        world.playBlockSoundEffect(null, blockPos.x() + 0.5F, blockPos.y() + 0.5F, blockPos.z() + 0.5F, this.statueBlockBottom, EnumBlockSoundEffectType.PLACE);
-        this.statueBlockBottom.onPlacedOnSide(world, blockPos, direction.side(), 0.5, 0.5);
-        this.statueBlockTop.onPlacedOnSide(world, blockPos.up(new TilePos()), direction.side(), 0.5, 0.5);
-
-        if (this.statueBlockBottom.isEntityTile && selfStack.getData().containsKey("tileEntityData")) {
-            TileEntity tileEntity = world.getTileEntity(blockPos);
-            if (tileEntity != null) {
-                tileEntity.readAdditionalData(selfStack.getData().getCompound("tileEntityData"));
-            }
-        }
-
-        selfStack.consumeItem(null);
+    public boolean canPlaceDirectlyAtPosition(
+        @NotNull ItemStack selfStack,
+        @NotNull World world, @Nullable Player player, @NotNull TilePosc blockPos,
+        @NotNull Side side, double xHit, double yHit
+    ) {
+        return
+            IPlaceable.canPlaceBlockDirectlyAtPosition(blockA, world, blockPos, side) &&
+            IPlaceable.canPlaceBlockDirectlyAtPosition(blockB, world, blockPos.up(new TilePos()), side);
     }
 }
diff --git a/game/core/src/main/java/net/minecraft/core/item/block/ItemBlock.java b/game/core/src/main/java/net/minecraft/core/item/block/ItemBlock.java
index deb28011a..7f2228482 100644
--- a/game/core/src/main/java/net/minecraft/core/item/block/ItemBlock.java
+++ b/game/core/src/main/java/net/minecraft/core/item/block/ItemBlock.java
@@ -2,124 +2,58 @@ package net.minecraft.core.item.block;
 
 import net.minecraft.core.block.Block;
 import net.minecraft.core.block.BlockLogic;
-import net.minecraft.core.block.Blocks;
-import net.minecraft.core.block.entity.TileEntity;
 import net.minecraft.core.block.entity.TileEntityActivator;
-import net.minecraft.core.block.tag.BlockTags;
 import net.minecraft.core.entity.player.Player;
-import net.minecraft.core.enums.EnumBlockSoundEffectType;
+import net.minecraft.core.item.IPlaceable;
 import net.minecraft.core.item.Item;
 import net.minecraft.core.item.ItemStack;
 import net.minecraft.core.util.helper.Direction;
 import net.minecraft.core.util.helper.Side;
 import net.minecraft.core.world.World;
-import net.minecraft.core.world.pos.TilePos;
 import net.minecraft.core.world.pos.TilePosc;
-import org.jetbrains.annotations.NotNull;
-import org.jetbrains.annotations.Nullable;
 
-import java.util.Objects;
 import java.util.Random;
 
-public class ItemBlock<T extends BlockLogic> extends Item {
-    protected @NotNull Block<T> block;
+import org.jetbrains.annotations.NotNull;
+import org.jetbrains.annotations.Nullable;
+
+public class ItemBlock<T extends BlockLogic> extends Item implements IPlaceable.PlaceableBlock<T> {
+    protected final @NotNull Block<T> block;
 
     public ItemBlock(@NotNull Block<T> block) {
         super(block.namespaceId(), block.getKey(), block.id());
-        this.block = Objects.requireNonNull(block);
-    }
-
-    public @NotNull Block<T> getBlock() {
-        return this.block;
+        this.block = block;
     }
 
     @Override
-    public boolean onUseOnBlock(
-        @NotNull ItemStack selfStack, @NotNull World world, @Nullable Player player,
-        @NotNull TilePosc blockPos, @NotNull Side side, double xHit, double yHit
-    ) {
-        if (shouldShift(world, blockPos, this.block)) blockPos = blockPos.add(side.direction(), new TilePos());
-        if (!world.canBlockIdBePlacedAt(this.block.id(), blockPos, false, side)) return false;
-
-        final int meta = getPlacedData(selfStack, world, player, blockPos, side, xHit, yHit);
-        return this.placeDirectly(selfStack, world, player, blockPos, meta, side, xHit, yHit);
-    }
-
-    public static boolean shouldShift(@NotNull World world, @NotNull TilePosc blockPos, @NotNull Block<?> block) {
-        if (!world.canPlaceInsideBlock(blockPos)) return true;
-        return block.hasTag(BlockTags.PLACE_OVERWRITES) && block == world.getBlockType(blockPos);
-    }
-
-    protected final boolean placeWithMeta(
-        @NotNull ItemStack selfStack, @NotNull World world, @Nullable Player player,
-        @NotNull TilePosc blockPos, int meta, @NotNull Side side, double xHit, double yHit
-    ) {
-        if (shouldShift(world, blockPos, this.block)) blockPos = blockPos.add(side.direction(), new TilePos());
-        if (!world.canBlockIdBePlacedAt(this.block.id(), blockPos, false, side)) return false;
-
-        return this.placeDirectly(selfStack, world, player, blockPos, meta, side, xHit, yHit);
-    }
-
-    protected final boolean placeDirectly(
-        @NotNull ItemStack selfStack, @NotNull World world, @Nullable Player player,
-        @NotNull TilePosc blockPos, int meta, @NotNull Side side, double xHit, double yHit
-    ) {
-        if (selfStack.stackSize <= 0) return false;
-        final var pbloc = world.getBlockType(blockPos);
-        final int pdata = world.getBlockData(blockPos);
-
-        if (!world.setBlockTypeDataRaw(blockPos, this.block, meta)) return false;
-
-        if (pbloc != this.block || pdata != meta) {
-            pbloc.onRemoved(world, blockPos, pdata);
-        }
-
-        selfStack.consumeItem(player);
-
-        if (player == null) {
-            this.block.onPlacedOnSide(world, blockPos, side, xHit, yHit);
-        } else {
-            this.block.onPlacedByMob(world, blockPos, side, player, xHit, yHit);
-        }
-
-        this.block.onPlacedByWorld(world, blockPos);
-
-        if (this.block.isEntityTile && selfStack.getData().containsKey("tileEntityData")) {
-            final TileEntity tileEntity = world.getTileEntity(blockPos);
-            if (tileEntity != null) {
-                tileEntity.readAdditionalData(selfStack.getData().getCompound("tileEntityData"));
-            }
-        }
-
-        world.notifyBlockChange(blockPos, this.block);
-        world.playBlockSoundEffect(
-            player,
-            blockPos.x() + 0.5F, blockPos.y() + 0.5F, blockPos.z() + 0.5F,
-            this.block, EnumBlockSoundEffectType.PLACE
-        );
-        return true;
+    public @NotNull String getKey() {
+        return this.block.getKey();
     }
 
     @Override
-    public void onUseByActivator(@NotNull ItemStack selfStack, @NotNull World world, @NotNull TileEntityActivator activator, @NotNull Random random, @NotNull TilePosc blockPos, @NotNull Direction direction, double offX, double offY, double offZ) {
-        blockPos = new TilePos(blockPos).add(direction);
-        @NotNull Block<?> b = world.getBlockType(blockPos);
-        if (b == Blocks.AIR || BlockTags.PLACE_OVERWRITES.appliesTo(b)) {
-            this.onUseOnBlock(selfStack, world, null, blockPos, direction.side(), 0.5, 0.5);
-        }
+    public @NotNull String getLanguageKey(@NotNull ItemStack selfStack) {
+        return this.block.getLanguageKey(selfStack.getMetadata());
     }
 
-    public int getPlacedData(@NotNull ItemStack selfStack, @NotNull World world, @Nullable Player player, @NotNull TilePosc blockPos, @NotNull Side side, double xHit, double yHit) {
-        return this.block.getPlacedData(player, selfStack, world, blockPos, side, xHit, yHit);
+    @Override
+    public @NotNull Block<T> getBlock() {
+        return this.block;
     }
 
     @Override
-    public @NotNull String getLanguageKey(@NotNull ItemStack selfStack) {
-        return this.block.getLanguageKey(selfStack.getMetadata());
+    public boolean onUseOnBlock(
+        @NotNull ItemStack selfStack, @NotNull World world, @Nullable Player player,
+        @NotNull TilePosc blockPos, @NotNull Side side, double xHit, double yHit
+    ) {
+        return this.placeOnBlock(selfStack, world, player, blockPos, side, xHit, yHit);
     }
 
     @Override
-    public @NotNull String getKey() {
-        return this.block.getKey();
+    public void onUseByActivator(
+        @NotNull ItemStack selfStack, @NotNull World world,
+        @NotNull TileEntityActivator activator, @NotNull Random random, @NotNull TilePosc blockPos,
+        @NotNull Direction direction, double offX, double offY, double offZ
+    ) {
+        this.placeByActivator(selfStack, world, activator, random, blockPos, direction, offX, offY, offZ);
     }
 }
diff --git a/game/core/src/main/java/net/minecraft/core/item/block/ItemBlockAlgae.java b/game/core/src/main/java/net/minecraft/core/item/block/ItemBlockAlgae.java
index 829a4db67..5ffc9a08d 100644
--- a/game/core/src/main/java/net/minecraft/core/item/block/ItemBlockAlgae.java
+++ b/game/core/src/main/java/net/minecraft/core/item/block/ItemBlockAlgae.java
@@ -3,14 +3,12 @@ package net.minecraft.core.item.block;
 import net.minecraft.core.block.Block;
 import net.minecraft.core.block.BlockLogic;
 import net.minecraft.core.block.BlockLogicFluid;
-import net.minecraft.core.block.Blocks;
 import net.minecraft.core.block.FluidWater;
 import net.minecraft.core.block.entity.TileEntityActivator;
 import net.minecraft.core.entity.player.Player;
 import net.minecraft.core.item.ItemStack;
 import net.minecraft.core.util.helper.Direction;
 import net.minecraft.core.util.helper.Side;
-import net.minecraft.core.util.phys.HitResult;
 import net.minecraft.core.world.World;
 import net.minecraft.core.world.pos.TilePos;
 import net.minecraft.core.world.pos.TilePosc;
@@ -28,45 +26,33 @@ public class ItemBlockAlgae<T extends BlockLogic> extends ItemBlock<T> {
     }
 
     @Override
-    public boolean onUseOnBlock(@NotNull ItemStack selfStack, @NotNull World world, @Nullable Player player, @NotNull TilePosc blockPos, @NotNull Side side, double xHit, double yHit) {
-        return false;
+    public boolean interactsWithFluid(@NotNull ItemStack selfStack) {
+        return true;
     }
 
     @Override
-    public @Nullable ItemStack onUse(@NotNull ItemStack selfStack, @NotNull World world, @NotNull Player player) {
-        final double reachDistance = player.getGamemode().getBlockReachDistance();
-        final HitResult rayCast = player.rayCast(reachDistance, 1f, true, false, false);
-        if (!(rayCast instanceof HitResult.Tile hitTile)) return selfStack;
-
-        final var pos = new TilePos(hitTile.tilePos);
-        if (!testPlace(world, pos)) return selfStack;
-
-        super.onUseOnBlock(selfStack, world, player, pos, Side.NONE, 0.5, 0.5);
-        return selfStack;
+    public boolean onUseOnBlock(
+        @NotNull ItemStack selfStack,
+        @NotNull World world, @Nullable Player player, @NotNull TilePosc tilePos,
+        @NotNull Side side, double xHit, double yHit
+    ) {
+        if (!this.isWaterSource(world, tilePos)) return false;
+        return super.placeWithoutShift(selfStack, world, player, tilePos.up(new TilePos()), Side.TOP, 0.5, 0.5);
     }
     
     @Override
     public void onUseByActivator(@NotNull ItemStack selfStack, @NotNull World world, @NotNull TileEntityActivator activator, @NotNull Random random, @NotNull TilePosc blockPos, @NotNull Direction direction, double offX, double offY, double offZ) {
         
         final var pos = new TilePos(blockPos).add(direction);
-        if (!testPlace(world, pos)) return;
+        if (!this.isWaterSource(world, pos)) return;
         
-        if (!world.setBlockType(pos, this.block)) return;
-        selfStack.consumeItem(null);
-
-        this.block.onPlacedOnSide(world, pos, Side.NONE, 0.5, 0.5);
-        world.notifyBlockChange(pos, this.block);
+        super.placeWithoutShift(selfStack, world, null, pos.up(), Side.TOP, 0.5, 0.5);
     }
 
-    private static final boolean testPlace(@NotNull World world, @NotNull TilePos toMove) {
-        final TilePos origin = new TilePos(toMove);
-
-        @NotNull Block<?> up = world.getBlockType(toMove.up());
-        if (up != Blocks.AIR) return false;
-
-        if (!(world.getBlockType(origin).getLogic() instanceof BlockLogicFluid fluid)) return false;
+    private final boolean isWaterSource(@NotNull World world, @NotNull TilePosc pos) {
+        if (!(world.getBlockType(pos).getLogic() instanceof BlockLogicFluid fluid)) return false;
         if (!(fluid.fluid instanceof FluidWater)) return false;
-        if (fluid.getDepth(world, origin) != 0) return false;
+        if (fluid.getDepth(world, pos) != 0) return false;
         return true;
     }
 }
diff --git a/game/core/src/main/java/net/minecraft/core/item/block/ItemBlockLadder.java b/game/core/src/main/java/net/minecraft/core/item/block/ItemBlockLadder.java
index 02ec02e26..4ba690e00 100644
--- a/game/core/src/main/java/net/minecraft/core/item/block/ItemBlockLadder.java
+++ b/game/core/src/main/java/net/minecraft/core/item/block/ItemBlockLadder.java
@@ -2,12 +2,17 @@ package net.minecraft.core.item.block;
 
 import net.minecraft.core.block.Block;
 import net.minecraft.core.block.BlockLogicLadder;
+import net.minecraft.core.block.entity.TileEntityActivator;
 import net.minecraft.core.entity.player.Player;
 import net.minecraft.core.item.ItemStack;
+import net.minecraft.core.util.helper.Direction;
 import net.minecraft.core.util.helper.Side;
 import net.minecraft.core.world.World;
 import net.minecraft.core.world.pos.TilePos;
 import net.minecraft.core.world.pos.TilePosc;
+
+import java.util.Random;
+
 import org.jetbrains.annotations.NotNull;
 import org.jetbrains.annotations.Nullable;
 
@@ -23,8 +28,8 @@ public class ItemBlockLadder<T extends BlockLogicLadder> extends ItemBlock<T> {
         final @NotNull BlockLogicLadder ladder = this.block.getLogic();
 
         final Side pside;
-        if (player == null || player.isSneaking() || world.getBlockType(bp) != this.block) {
-            if (shouldShift(world, bp, this.block)) bp.add(side.direction());
+        if ((player != null && player.isSneaking()) || world.getBlockType(bp) != this.block) {
+            if (super.shouldShiftOutOf(selfStack, world, player, bp, side, xHit, yHit)) bp.add(side.direction());
             pside = ladder.getSideForPlacement(world, bp, side);
         } else {
             xHit = 0.5;
@@ -39,4 +44,14 @@ public class ItemBlockLadder<T extends BlockLogicLadder> extends ItemBlock<T> {
         if (!ladder.canExistAt(world, bp, meta)) return false;
         return super.placeDirectly(selfStack, world, player, bp, meta, pside, xHit, yHit);
     }
+
+    @Override
+    public void onUseByActivator(@NotNull ItemStack selfStack,
+        @NotNull World world,
+        @NotNull TileEntityActivator activator, @NotNull Random random, @NotNull TilePosc blockPos,
+        @NotNull Direction direction, double offX, double offY, double offZ
+    ) {
+        blockPos = blockPos.add(direction, new TilePos());
+        this.onUseOnBlock(selfStack, world, null, blockPos, direction.opposite().side(), Double.NaN, Double.NaN);
+    }
 }
diff --git a/game/core/src/main/java/net/minecraft/core/item/block/ItemBlockLayer.java b/game/core/src/main/java/net/minecraft/core/item/block/ItemBlockLayer.java
index 0d4f4bf49..29df0de45 100644
--- a/game/core/src/main/java/net/minecraft/core/item/block/ItemBlockLayer.java
+++ b/game/core/src/main/java/net/minecraft/core/item/block/ItemBlockLayer.java
@@ -3,68 +3,44 @@ package net.minecraft.core.item.block;
 import net.minecraft.core.block.Block;
 import net.minecraft.core.block.BlockLogicLayerBase;
 import net.minecraft.core.entity.player.Player;
-import net.minecraft.core.enums.EnumBlockSoundEffectType;
+import net.minecraft.core.item.IAccumulatable;
 import net.minecraft.core.item.ItemStack;
 import net.minecraft.core.util.helper.Side;
 import net.minecraft.core.world.World;
-import net.minecraft.core.world.pos.TilePos;
 import net.minecraft.core.world.pos.TilePosc;
+
 import org.jetbrains.annotations.NotNull;
 import org.jetbrains.annotations.Nullable;
-import org.joml.Vector3d;
-import org.joml.primitives.AABBd;
 
 
-public class ItemBlockLayer<T extends BlockLogicLayerBase> extends ItemBlock<T> {
+public class ItemBlockLayer<T extends BlockLogicLayerBase> extends ItemBlock<T> 
+    implements IAccumulatable<T>
+{
     public ItemBlockLayer(@NotNull Block<T> block) {
         super(block);
     }
 
-    // TODO: sideways placement into layer
     @Override
-    public boolean onUseOnBlock(@NotNull ItemStack selfStack, @NotNull World world, @Nullable Player player, @NotNull TilePosc tilePos, @NotNull Side side, double xHit, double yHit) {
-        if (selfStack.stackSize <= 0) return false; 
-        if (tilePos.y() == world.getHeightBlocks() - 1 && this.block.getMaterial().isSolid()) {
-            return false;
-        }
-        final var targetBlock = world.getBlockType(tilePos);
-        if (targetBlock != this.block || side != Side.TOP) {
-            // you can no longer stack layers by placing on
-            // the top face of a partial block under the layers :3
-            return super.placeWithMeta(selfStack, world, player, tilePos, 0, side, xHit, yHit);
-        }
-
-        final @NotNull BlockLogicLayerBase blockLayer = this.block.getLogic();
-        final int meta = world.getBlockData(tilePos) + 1;
-
-        final var bbmin = new Vector3d(tilePos.vec());
-        final var bbmax = new Vector3d(bbmin).add(1, (meta + 1) / 8.0f, 1);
-        if (!world.checkIfAABBIsClear(new AABBd(bbmin, bbmax))) return false;
-
-        final boolean placed;
-        final @NotNull Block<?> placedBlock;
-        final var placedPos = new TilePos(tilePos);
+    public boolean canAccumulateInto(
+        @NotNull ItemStack selfStack,
+        @NotNull Block<?> block, int data, @NotNull Side side, double xHit, double yHit
+    ) {
+        return block == this.block && !(yHit - ((data + 1) * 0.125) <= -0x1p-12);
+    }
 
-        if (meta < 7) {
-            placedBlock = this.block;
-            placed = world.setBlockTypeData(placedPos, placedBlock, meta);
-        } else if (blockLayer.fullBlock != null) {
-            placedBlock = blockLayer.fullBlock;
-            placed = world.setBlockType(placedPos, placedBlock);
+    @Override
+    public @NotNull BlockDataResult getAccumulationResult(
+        @NotNull ItemStack selfStack,
+        @NotNull World world, @Nullable Player player, @NotNull TilePosc tilePos,
+        @NotNull Side side, double xHit, double yHit,
+        @NotNull BlockDataResult result
+    ) {
+        if (result.data < 6) {
+            result.data += 1;
         } else {
-            placedBlock = this.block;
-            // TODO this can place inside entities
-            placed = world.setBlockType(placedPos.up(), placedBlock);
+            result.block = this.block.getLogic().fullBlock;
+            result.data = 0;
         }
-        if (!placed) return false;
-        selfStack.consumeItem(player);
-
-        placedBlock.onPlacedByMob(world, tilePos, side, player, xHit, yHit);
-        world.notifyBlockChange(placedPos, placedBlock);
-
-        world.playBlockSoundEffect(player,
-            placedPos.x() + 0.5F, placedPos.y() + 0.5F, placedPos.z() + 0.5F,
-            this.block, EnumBlockSoundEffectType.PLACE);
-        return true;
+        return result;
     }
 }
